package de.org.grp.back;

import java.util.Collection;

import javax.enterprise.inject.Model;
import javax.inject.Inject;

import de.org.grp.domain.Customer;
import de.org.grp.sl.CustomerService;

@Model
public class Initializer {

    @Inject
    CustomerService custService;

    public void executeCustomerActivities() {

        Customer customer = null;

        // create some customers
        customer = custService.createCustomer("Michael Green", 54321);
        System.out.println("\nPersisted " + customer + "\n");
        customer = custService.createCustomer("Barbara White", 76543);
        System.out.println("\nPersisted " + customer + "\n");
        customer = custService.createCustomer("George Blue", 1543);
        System.out.println("\nPersisted " + customer + "\n");

        // find a specific customer
        customer = custService.findCustomerByName("Michael Green");
        System.out.println("\nFound customer by name: " + customer + "\n");

        // find all customers
        System.out.println("\nAll customers:");
        Collection<Customer> customers = custService.findAllCustomers();
        for (Customer e : customers)
            System.out.println("\nFound Customer: " + e + "\n");

        // update the customer
        customer = custService.raiseCustomerSalary("Michael Green", 230);
        System.out.println("\nUpdated salary: " + customer + "\n");

        // remove an customer
        custService.removeCustomer("Barbara White");
        System.out.println("\nRemoved Customer Barbara White" + "\n");

    }
}
