package de.org.grp.domain;

import javax.persistence.*;
import java.io.Serializable;

@Entity
@NamedQuery(name = "findCustomerByName",
        query = "SELECT c FROM Customer c WHERE c.name = :nameParam")
public class Customer implements Serializable {

	private static final long serialVersionUID = -8059187335560003979L;

	@Id
    @TableGenerator(name="CustIdGen",
            table="ID_CUSTOMER",
            pkColumnName="GEN_NAME",
            valueColumnName="GEN_VAL")
    @GeneratedValue(generator="CustIdGen")
    private Long id;

    @Column
    private String name;

    @Column
    private Long salary;

    public Customer() { }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Long getSalary() {
        return salary;
    }

    public void setSalary(Long salary) {
        this.salary = salary;
    }

    @Override
    public String toString() {
        return "Customer id: " + getId() + " name: " + getName() + " salary: " + getSalary();
    }
}
