package de.org.grp.sl;

import java.util.Collection;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import de.org.grp.domain.Customer;

@Stateless
public class CustomerService {

    @PersistenceContext(unitName = "CustomerService")
    private EntityManager em;

    public Customer createCustomer(String name, long salary) {
        Customer customer = new Customer();
        customer.setName(name);
        customer.setSalary(salary);
        em.persist(customer);
        return customer;
    }

    public void removeCustomer(String nameParam) {
        Customer customer = (Customer) em.createNamedQuery("findCustomerByName", Customer.class).setParameter("nameParam",nameParam).getSingleResult();
        if (customer != null) {
            em.remove(customer);
        }
    }

    public Customer raiseCustomerSalary(String nameParam, long raise) {
        Customer customer = (Customer) em.createNamedQuery("findCustomerByName", Customer.class).setParameter("nameParam",nameParam).getSingleResult();
        if (customer != null) {
            customer.setSalary(customer.getSalary() + raise);
        }
        return customer;
    }

    public Customer findCustomer(long id) {
        return em.find(Customer.class, id);
    }

    public Collection<Customer> findAllCustomers() {
        Query query = em.createQuery("SELECT e FROM Customer e");
        return (Collection<Customer>) query.getResultList();
    }

    public Customer findCustomerByName(String nameParam) {
        Customer customer = (Customer) em.createNamedQuery("findCustomerByName", Customer.class).setParameter("nameParam",nameParam).getSingleResult();

        return customer;
    }

}
